\chapter{Results\label{sec:results}}

\section{Dataset creation from Tacyt}

In order to be able to run the CHABADA implementation over Tacyt I first needed to build a dataset. This dataset, as explained in Section~\ref{sec:tacyt}, starts with the CISPA dataset. This dataset has around 1.6 million of applications. From this dataset I only took the package names. Using this package names I can query Tacyt with the data for each application. During the dataset creation I setup a series of filters or conditions that each application in the final dataset must hold. The raw numbers of the process are described in Table~\ref{raw_dataset_numbers}.

\begin{table}[h!]
\centering
\begin{tabular}{@{}ll@{}}
\toprule
                                                                  & \textbf{Number of apps} \\ \midrule
\multicolumn{1}{l}{\textbf{CISPA dataset}}                       & 1658808                 \\ \midrule
\multicolumn{1}{l}{\textbf{Apps not found in Tacyt}}             & 440184                  \\ \midrule
\multicolumn{1}{l}{\textbf{Apps with missing required fields}}   & 143131                  \\ \midrule
\multicolumn{1}{l}{\textbf{Apps with a non English description}} & 334747                  \\ \midrule
\multicolumn{1}{l}{\textbf{Final dataset size}}                  & 740746                  \\ \bottomrule
\end{tabular}
\caption{The results of each filtering step and the final size of the dataset.}
\label{raw_dataset_numbers}
\end{table}

From the apps with missing fields, all of them didn't had the \code{sha256} field. This field was required because this hash is used for referencing the application binary when downloading from Androzoo.

% XXX: Anything else here? I think is ok as is

\section{Evaluation of the dataset in CHABADA}

To check the performance of the dataset, I ran the pipeline measuring the time each time took to complete. I configured the chunk size to be 50000, which created 15 chunks. Each chunk was assigned to a worker. Some tasks didn't supported chunking, so the running time of the task is the running time of a single instance. The running time of each task is described in Table~\ref{running_times}. The times in the table are the rounded average because each task had each own running time but all of them where very similar. Also, given this running times, a difference of seconds or even minutes is irrelevant.

\begin{table}[h!]
\centering
\begin{tabular}{@{}lll@{}}
\toprule
\textbf{Task} & \textbf{Approximate running time} & \textbf{Number of workers} \\ \midrule
Cleanup of description for LDA          & 2 hours                  & 15  \\ \midrule
Storing descriptions to text files          & 4 hours and 30 minutes                 & 15  \\ \midrule
Execution of Mallet          & 2 hours                 & 1  \\ \midrule
Kmeans              & 20 minutes                          & 1                           \\ \bottomrule
\end{tabular}
\caption{The approximate times each task took to complete. Multiply by the number of workers to get the approximate CPU time.}
\label{running_times}
\end{table}

These times are not ideal, but they are to be expected. Once this metrics where taken, I proceeded to optimize the parameters of the machine learning algorithms. The parameters that I wanted to optimize are the number of topics and the number of clusters. The first step was to determine a good range of number of topics. I tried with 20, 30, 40, 50, 70, 90, 100, 150 and 200. After manual inspection of the resulting topics, 30 topics where the number of topics that made more sense. 20 topics produced topics that spoke about too many things and in 50 and above the topics became redundant. 30 to 40 topics seems like the correct number of topics. Table~\ref{topics_table_30} shows the topics obtained. Once I had this range the next step is to get the number of clusters.

%% \begin{table}[h!]
%% \centering
\begin{longtable}{@{}llp{0.5\textwidth}@{}}
\toprule
\textbf{Topic No.} & \textbf{Assigned name} & \textbf{Most Representative Words} \\ \midrule
0                  & quiz and puzzle games  & game, play, puzzle, challenge, quiz, answer, difficulti, correct, memori \\ \midrule                       	% quiz and puzzle games
1                  & health and fitness     & bodi, health, exercis, workout, weight, fit, train, gym, medicin, doctor, lifestyl \\ \midrule 		% health and fitness
2                  & military games         & game, enemy, shoot, zombi, war, attack, shooter, aim, warrior, aircraft, missile, strategi \\ \midrule 	% military games
3                  & gambling and casino games & game, football, world, poker, solitari, basketball, casino, prize, bet \\ \midrule 				% gambling and casino games
4                  & spirituality and religion & bibl, god, holy, jesus, muslim, spirit, worship, part, religion, roman, gospel, zodiac \\ \midrule 		% spirituality and religion
5                  & languages and dictionary & word, learn, languag, translat, dictionary, spanish, vocabulari, italian, japanes, nativ \\ \midrule 		% languages and dictionary
6                  & money and business  & bank, payment, coupon, financi, budget, card, pay, purchas, market, incom, credit \\ \midrule 			% money and business 
7                  & cooking & recip, food, cook, cake, pizza, quick, simpl, diet, beef, vegan, cookbook, fruit, bake \\ \midrule 		% cooking
8                  & platform games & game, jump, collect, adventur, score, coin, obstacl, speed, enemi, funni \\ \midrule 				% platform games
9                  & social media & facebook, whatsapp, off-line, photo, email, social, status, chat, instagram \\ \midrule 				% social media
10                 & music & sound, rignton, music, play, voic, alarm, guitar, instrument, volum, speaker, melodi \\ \midrule 			% music
11                 & photography & photo, frame, pictur, imag, effect, share, camera, wallpaper, blur, stylish, photographi, captur \\ \midrule 	% photography
12                 & planification apps & news, inform, updat, schedul, program \\ \midrule 									% planificación apps
13                 & home screen personalization & widget, clock, menu, icon, unlock, bar, hide, lock screen, custom, launch \\ \midrule 				% home screen personalization
14                 & cloud drive apps & video, download, view, edit, player, playback, cloud, pdf, export, librari, upload \\ \midrule 			% cloud drive apps
15                 & Candy Crush lookalikes & game, bubbl, free, level, candi, puzzle, jewel, jackpot, destroy, combo\\ \midrule					% Candy Crush lookalikes
16                 & kids games & game, kid, child, learn, babi, rhyme, pet, doodl, educ, alphabet, paint \\ \midrule				% kids games
17                 & self help apps & help, peopl, chanc, posit, learn, chang, success, inspir \\ \midrule						% self help apps
18                 & online television \& radio & radio, station, tv, program, televis, youtub, satelli, trailer, wherev, sport \\ \midrule 				% online television & radio
19                 & calculator apps & call, number, data, measure, unit, rate, convert, currenc, length, mathemat \\ \midrule				% calculator apps
20                 & general customisation & theme, keyboard, launcher, background, smiley, decor, screenshot \\ \midrule					% general customisation
21                 & gamer communities & game, top, mod, unoffici, guidelin, friend, skin, tutori, player, clan, fandom, strategy \\ \midrule		% gamer communities
22                 & system monitoring apps & devic, use, batteri, system, password, remot, bluetooth, memory, monitor, cpu \\ \midrule				% system monitoring apps
23                 & home decor apps & design, room, home, garden, craft, floor, bathroom, architectur, lamp, colour \\ \midrule				% home decor apps
24                 & ads and policies & free, version, ad, rate, feedback, click, websit, licens, polici \\ \midrule					% ads and policies
25                 & racing games & car, drive, race, truck, driver, road, citi, bike, speed, traffic, rider, game \\ \midrule				% racing games
26                 & institutional apps & servic, industri, govern, confer, univers, website, institut, \\ \midrule						% institutional apps
27                 & dressing games & design, dress, girl, hair, fashion, style, beauty, necklac, skirt, wear \\ \midrule				% dressing games
28                 &  traveling apps & map, local, citi, travel hotel, guid, gps, local, rester, visit, trip \\ \midrule					% traveling apps
29                 & wallpaper apps & wallpaper, live, free, image, background, beauty, set, anim, download, picture \\ \bottomrule			% wallpaper apps
\caption{The 30 topics extracted from the dataset of applications.}
\label{topics_table_30}
\end{longtable}
%% \end{table}

% Table with the topics like in the CHABADA paper?

To find the correct combination of number of topics and clusters I run a matrix of topics and clusters. The parameter of the topics went from 30 to 40 and the parameter of clusters from 25 to 35. For each combination I tried to obtain the silhouette. The silhouette is an score from -1 to 1 that determines how well situated are the elements of a cluster compared to it's neighbors. It is used to evaluate the fitness of the K parameter in the Kmeans algorithm. With the 25\% of sampling for the silhouette I obtained the results of the silhouette for that range. A heatmap of the different values of the silhouette is in figure \ref{silhouette_heatmap}.

\begin{figure}[h!]
  \includegraphics[scale=0.95]{graphics/silhouette-heatmap}
  \caption{The heatmap of the different silhouette values.}
  \label{silhouette_heatmap}
\end{figure}

\section{Results from the graph of applications}

\subsection{Results from using the Graph to evaluate the clusters}

Using the scoring system explained in the implementation chapter, I evaluated the hyperparameters in the same range as the silhouette. However, I used a 10\% of sampling in this case for efficiency reasons. The results can be seen in Figure \ref{graph_heatmap}

\begin{figure}[h!]
  \includegraphics[scale=1]{graphics/graph-heatmap}
  \caption{The heatmap of the different scores.}
  \label{graph_heatmap}
\end{figure}

\subsection{Missing apps}

From the graph of applications I got some interesting results apart from the actual graph. The main one is that most of my dataset was missing from the Google Play store, this can be because many reasons, but the most probable one is that this apps where actually \emph{crapware} and where removed from the store in consequence of a violation of the guidelines. One example of this applications is one that predicts whenever a pregnant woman will have a boy or a girl.

%% TODO: Expand a little on the example with the data I have about that app.

One result that is worth noticing is that, as show in Table \ref{distribution_of_apps}, some applications that are missing from the store have applications that are related to them. A possible explanation of this is that Google stores the related apps information separately from the actual app information. And once an app is removed it may take some time to remove that information. It is likely that Google has a very paranoid database administration policy and information will take a long time to be removed. 

\begin{table}[h!]
  \centering
\begin{tabular}{lllll}
\textbf{Status} & \textbf{No similar field} & \textbf{With similar} & \textbf{Without similar} & \textbf{Total} \\ \hline
Missing         & 13257 (1.79\%)             & 33027 (4.46\%)         & 450813 (60.86\%)          & 497097 (67.11\%)                     \\
Found           & 6746 (0.91\%)              & 225079 (30.39\%)       & 11809 (1.59\%)            & 243634 (32.89\%)                     \\
Total           & 20003 (2.70\%)             & 278123 (37.55\%)       & 462623 (62.45\%)          & 720743 (97.30\%)                    
\end{tabular}
\caption{The distribution of apps of the dataset in the results of the scrapper.}
\label{distribution_of_apps}
\end{table}

\section{Results from classifying the applications with KNN}

From the results obtained in the evaluation of the hyperparameters I obtained that, according to the graph scoring, the best hyperparameters are 34 clusters and 30 topics. Using this hyperparameters I calculated the anomalies in the clusters using KNN. For the features used in the anomaly detection I used the permissions of the applications that are declared in their manifests. The permissions are an usable approximation of what an application is expected to do, because it can't do more than what is declared in the permissions. From the results of the classification I got the scores of the applications that I found that are missing in the Google Play Store. Figures \ref{knn_missing} and \ref{knn_found} shows the scores for each application missing and found respectively. As can be seen in the figures, there is no apparent relationship between the fact that an application is missing from the Google Play Store and that an application is considered an outlier by KNN. In the case of the missing applications, around 30\% of them have an score greater than 0. In the case of the found applications the percentage is around 35\%. This means that being malware is not the only reason Google might have to remove an application from the store. The second most probable reason is an expired developer license. An explanation of a possible way of checking if this is the case is mentioned in the next chapter.

\begin{figure}[h!]
  \includegraphics[scale=0.45]{graphics/knn_missing}
  \caption{Missing apps by their score in KNN}
  \label{knn_missing}
\end{figure}

\begin{figure}[h!]
  \includegraphics[scale=0.45]{graphics/knn_found}
  \caption{Found apps by their score in KNN}
  \label{knn_found}
\end{figure}
